;;;; embedded "crunch" macro test

(import (scheme base) crunch (chicken fixnum) (chicken bitwise))

(crunch
  (define (popcount32 x)
    (let ((x (fx- x (bitwise-and (arithmetic-shift x -1) #x55555555))))
      (let ((x (fx+ (bitwise-and x #x33333333)
                  (bitwise-and (arithmetic-shift x -2) #x33333333))))
        (let ((x (bitwise-and (fx+ x (arithmetic-shift x -4)) #x0F0F0F0F)))
          (let ((x (fx+ x (arithmetic-shift x -8))))
            (let ((x (fx+ x (arithmetic-shift x -16))))
              (bitwise-and x #x0000003F))))))))

(assert (= (popcount32 63) 6))
(assert (= (popcount32 64) 1))
(assert (= (popcount32 65) 2))

(crunch
  (: (foo bytevector) integer)
  (define (foo b)
    (bytevector-length b)))

(assert (= (foo #(9 10 11)) 3))
